// Requires: lib.system, lib.tools

// TODO: preParse does not work correctly with rotation.

var config = function() {
	var self = {
		preParse: false,
		config: {},
		parsed: {}
	};

	self.load = function(config, preParse) {
		if(typeof(preParse)!='undefined') {
			if(preParse) {
				self.preParse = true;
			} else {
				self.preParse = false;
			}
		}
		self.config = config;
		if(self.preParse) {
			self.parsed = self.parseConfig(config);
		}
	};

	self.get = function(subArea, key, fallback) {
		if(self.preParse) {
			var ret = self.getParsed(subArea, key, fallback);
		} else {
			var ret = self.getDirect(subArea, key, fallback);
		}
		var direct = self.getDirect(subArea, key, fallback);
		if(direct!=ret) {
		}
		return ret;
	};
	
	self.getDirect = function(subArea, key, fallback) {
		var i, area, checkData, foundArea;
		var ret = fallback;
		var orientation = lib.rotate.getOrientation();
		var checkAreas = [
			'default',
			lib.system.form,
			lib.system.platform,
			orientation,
			lib.system.platform+'_'+lib.system.form,
			lib.system.platform+'_'+orientation,
			lib.system.form+'_'+orientation,
			lib.system.platform+'_'+lib.system.form+'_'+orientation
		];
		if(typeof(key)!='string' || key.length<1) {
			key = subArea;
			subArea = '';
		}
		for(i in checkAreas) {
			area = checkAreas[i];
			if(typeof(self.config[area])!='undefined') {
				checkData = self.config[area];
			} else {
				checkData = {};
			}
			if(subArea.length>0) {
				if(typeof(checkData[subArea])!='undefined') {
					checkData = checkData[subArea];
				} else {
					checkData = {};
				}
			}
			if(typeof(checkData[key])!='undefined') {
				ret = checkData[key];
				foundArea = area;
			}
		}
		return ret;
	};

	self.parseConfig = function(config) {
		parsed = {};
		var orientations = ['landscape', 'portrait'];
		var orientation, checkAreas, area;
		for(var o in orientations) {
			orientation = orientations[o];
			parsed[orientation] = {};
			checkAreas = [
				'default',
				lib.system.form,
				lib.system.platform,
				orientation,
				lib.system.platform+'_'+lib.system.form,
				lib.system.platform+'_'+orientation,
				lib.system.form+'_'+orientation,
				lib.system.platform+'_'+lib.system.form+'_'+orientation
			];
			for(a in checkAreas) {
				area = checkAreas[a];
				for(var c1 in config[area]) {
					if(typeof(parsed[orientation][c1])!='object') {
						parsed[orientation][c1] = config[area][c1];
					}
					if(typeof(config[area][c1])=='object') {
						for(var c2 in config[area][c1]) {
							parsed[orientation][c1][c2] = config[area][c1][c2];
						}
					}
				}
			}
		}
		return parsed;
	};
	
	self.getParsed = function(subArea, key, fallback) {
		var orientation = lib.rotate.getOrientation();
		if(typeof(key)=='undefined') {
			if(typeof(self.parsed[orientation][subArea])!='undefined') {
				return self.parsed[orientation][subArea];
			} else {
				return fallback;
			}
		} else {
			if(typeof(self.parsed[orientation][subArea])!='undefined' && typeof(self.parsed[orientation][subArea][key])!='undefined') {
				return self.parsed[orientation][subArea][key];
			} else {
				return fallback;
			}
		}
	};
	
	return self;
}

module.exports = config();