// TODO: Add "requires" to all libs, check this while loading

var lib = function() {
	var self = {
		libName: 'lib',
		incPath: 'lib/',
		libSets: {
			all: [
				'audio',
				'cache',
				'config',
				'debug',
				'net',
				'phpjs',
				'profile',
				'rotate',
				'system',
				'tools',
				'UI',
				'window',
				'xml'
			]
		},
		loggingEnabled: true,
		loggingIgnorePrefixes: [],
		logText: ''
	};

	self.loadLib = function(libName) {
		self[libName] = require(self.incPath+libName);
		self[libName].libName = libName;
		self[libName].log = function(msg, subPrefix) {
			self.log(msg, libName, subPrefix);
		};
	};

	self.load = function(libs, incPath) {
		if(typeof(libs)=='undefined') {
			libs = 'all';
		}

		if(typeof(libs)=='string' && typeof(self.libSets[libs])!='undefined') {
			libs = self.libSets[libs];
		}

		if(incPath) {
			self.incPath = incPath;
		}

		if(typeof(libs)=='object') {
			for(var i in libs) {
				self.loadLib(libs[i]);
			}
		}
	};

	self.enableLogging = function() {
		self.loggingEnabled = true;
	};

	self.loggingIgnorePrefixes = function(loggingIgnorePrefixes) {
		self.loggingIgnorePrefixes = loggingIgnorePrefixes;
	};

	self.log = function(msg, prefix, subPrefix) {
		if(self.loggingEnabled && !self.phpjs.in_array(prefix, self.loggingIgnorePrefixes)) {
			if(!prefix) {
				prefix = 'UNKNOWN';
			}
			if(typeof(subPrefix)!='undefined') {
				prefix += '/'+subPrefix;
			}
			var logPrefix = '['+prefix+']';
			if(typeof(msg)=='array' || typeof(msg)=='object') {
				Titanium.API.log('INFO', logPrefix+' '+typeof(msg)+' =>');
				Titanium.API.log('INFO', msg);
			} else {
				Titanium.API.log('INFO', logPrefix+' '+msg);
			}
			self.logText += logPrefix+' '+msg+"\n";
		}
	};

	return self;
};

module.exports = lib();
